#include <iostream>
using namespace std;
struct pacijent
{
    string grupa;
    int jedinica;
    int resenje1=0;
    int resenje2=0;
    int resenje3=0;
    int resenje4=0;
};

int main ()
{
    int o=0,a=0,b=0,ab=0,n;
    cin>>n;
    cin>>o>>a>>b>>ab;
    pacijent pacijenti [n];
    for (int i=0;i<n;i++)
    {
        cin>>pacijenti[i].grupa>>pacijenti[i].jedinica;
    }
    //O
    for (int i=0;i<n;i++)
    {
        if (pacijenti[i].grupa=="O")
        {
            o-=pacijenti[i].jedinica;
            if (o<0)
            {
                cout<<"nemoguce";
                return 0;
            }
            pacijenti[i].resenje1+=pacijenti[i].jedinica;
        }
    }
    //A
    int i=0;
    for (i=0;i<n && o>0;i++)
    {
        if (pacijenti[i].grupa=="A")
        {
            o-=pacijenti[i].jedinica;
            if (o<0)
            {
                pacijenti[i].resenje1+=pacijenti[i].jedinica+o;
                pacijenti[i].jedinica=-o;
                o=0;
                break;
            }
            pacijenti[i].resenje1+=pacijenti[i].jedinica;
        }
    }
    for (i=i;i<n;i++)
    {
        if (pacijenti[i].grupa=="A")
        {
            a-=pacijenti[i].jedinica;
            if (a<0)
            {
                cout<<"nemoguce";
                return 0;
            }
            pacijenti[i].resenje2+=pacijenti[i].jedinica;
        }
    }
    //B
    i=0;
    for (i=0;i<n && o>0;i++)
    {
        if (pacijenti[i].grupa=="B")
        {
            o-=pacijenti[i].jedinica;
            if (o<0)
            {
                pacijenti[i].resenje1+=pacijenti[i].jedinica+o;
                pacijenti[i].jedinica=-o;
                o=0;
                break;
            }
            pacijenti[i].resenje1+=pacijenti[i].jedinica;
        }
    }
    for (i=i;i<n;i++)
    {
        if (pacijenti[i].grupa=="B")
        {
            b-=pacijenti[i].jedinica;
            if (b<0)
            {
                cout<<"nemoguce";
                return 0;
            }
            pacijenti[i].resenje3+=pacijenti[i].jedinica;
        }
    }
    //AB
    i=0;
    for (i=0;i<n && o>0;i++)
    {
        if (pacijenti[i].grupa=="AB")
        {
            o-=pacijenti[i].jedinica;
            if (o<0)
            {
                pacijenti[i].resenje1+=pacijenti[i].jedinica+o;
                pacijenti[i].jedinica=-o;
                o=0;
                break;
            }
            pacijenti[i].resenje1+=pacijenti[i].jedinica;
        }
    }
    for (i=i;i<n && a>0;i++)
    {
        if (pacijenti[i].grupa=="AB")
        {
            a-=pacijenti[i].jedinica;
            if (a<0)
            {
                pacijenti[i].resenje2+=pacijenti[i].jedinica+a;
                pacijenti[i].jedinica=-a;
                a=0;
                break;
            }
            pacijenti[i].resenje2+=pacijenti[i].jedinica;
        }
    }
    for (i=i;i<n && b>0;i++)
    {
        if (pacijenti[i].grupa=="AB")
        {
            b-=pacijenti[i].jedinica;
            if (b<0)
            {
                pacijenti[i].resenje3+=pacijenti[i].jedinica+b;
                pacijenti[i].jedinica=-b;
                b=0;
                break;
            }
            pacijenti[i].resenje3+=pacijenti[i].jedinica;
        }
    }
    for (i=i;i<n;i++)
    {
        if (pacijenti[i].grupa=="AB")
        {
            ab-=pacijenti[i].jedinica;
            if (ab<0)
            {
                cout<<"nemoguce";
                return 0;
            }
            pacijenti[i].resenje4+=pacijenti[i].jedinica;
        }
    }
    cout<<"moguce"<<endl;
    for (i=0;i<n;i++)
    {
        cout<<pacijenti[i].resenje1<<" "<<pacijenti[i].resenje2<<" "<<pacijenti[i].resenje3<<" "<<pacijenti[i].resenje4<<endl;
    }
    return 0;
}